//MyRTTI.cpp
#include <stdarg.h>
#include "MyRTTI.h"

MyRTTI::MyRTTI (const char* pcName) : m_pcClassName(pcName), m_numParent(0), m_pParentRTTI(0)
{

}
//-------------------------------------------------------------------------------------------------
MyRTTI::MyRTTI(const char* pcName, const MyRTTI & baseRTTI) : m_pcClassName(pcName), m_numParent(1)
{
	m_pParentRTTI = new const MyRTTI*[1];
	m_pParentRTTI[0] = &baseRTTI;
}
//-------------------------------------------------------------------------------------------------
MyRTTI::MyRTTI(const char* pcName, int numParent, ...) : m_pcClassName(pcName), m_numParent(numParent)
{
    if (numParent == 0)
    {
        m_pParentRTTI  = 0;
    }
    else
    {
        m_pParentRTTI = new const MyRTTI*[m_numParent];

        va_list v;
        va_start(v, numParent);
        for (int i=0; i < m_numParent; ++i) 
        {
            m_pParentRTTI[i] = va_arg(v, const MyRTTI*);
        }
        va_end(v);
    }
}
//-------------------------------------------------------------------------------------------------
MyRTTI::~MyRTTI()
{
	if( m_pParentRTTI )
		delete [] m_pParentRTTI;
}
//-------------------------------------------------------------------------------------------------
const char* MyRTTI::GetClassName ()  const  
{
	return m_pcClassName;   
}
//-------------------------------------------------------------------------------------------------
bool MyRTTI::DerivedFrom (const MyRTTI & rtti) const
{
    const MyRTTI * pCompare = this;
    if (pCompare == &rtti)
        return true;

    for (int i=0; i < m_numParent; ++i)
    {
        if (m_pParentRTTI[i]->DerivedFrom(rtti))
            return true;
    }

    return false;
}
