//MyRTTI.h
#ifndef __MYRTTI_H
#define __MYRTTI_H

#define MyDeclareRTTI  \
	public:	\
	static	const MyRTTI	m_rtti;	\
	virtual const MyRTTI &  GetRTTI() const	{	return m_rtti;	}

#define MyImplementBaseRTTI(name)	\
	const MyRTTI name::m_rtti(#name);

#define MyImplementRTTI(name, parent)		\
	const MyRTTI name::m_rtti(#name, parent::m_rtti); 

#define MyImplementRTTI2(name, parent1, parent2)		\
	const MyRTTI name::m_rtti (#name, 2, &##parent1::m_rtti, &##parent2::m_rtti);


#define MySameClass(a, b)   (&(a).GetRTTI() == &(b).GetRTTI())
#define MyDerivedFrom(parentClass, object)     (   (object).GetRTTI().DerivedFrom( ##parentClass::m_rtti )    )



class MyRTTI
{
public:
	MyRTTI(const char* pcName);
	MyRTTI(const char* pcName, const MyRTTI & baseRTTI);
    MyRTTI(const char* pcName, int numParent, ...);
    ~MyRTTI();

	const   char* GetClassName ()  const;
	bool	DerivedFrom (const MyRTTI & rtti) const;

private:
	const	char* 	m_pcClassName;
	const	int		m_numParent;
    const	MyRTTI ** m_pParentRTTI;
};

#endif